/********************************************************************************************************
 * - PAN ID: 0x2176 for example										 								*
 * - Short address: 0x0000 ~ 0xFFFF changeable															*
 ********************************************************************************************************/

#include "include\include.h"

//-------------------------------------------------------------------------------------------------------
// Basic RF transmission and reception structures
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO rfRxInfo;
BASIC_RF_TX_INFO rfTxInfo;
BYTE pTxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];
BYTE pRxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];

//-------------------------------------------------------------------------------------------------------
// (7) ڰ ʿ信   ܺκ
//-------------------------------------------------------------------------------------------------------
//
//  ܺκ ߰
//
volatile unsigned int Upperaddr, Loweraddr;

//-------------------------------------------------------------------------------------------------------
// (8) ڰ ʿ信   Լ ⿡ ϰų  .c Ͽ Ѵ.
//-------------------------------------------------------------------------------------------------------
//
//  Լ ߰
//

//-------------------------------------------------------------------------------------------------------
//	 Ȥ κ Ÿ  ó Լ(ͷƮ ڵ鷯)
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO* basicRfReceivePacket(BASIC_RF_RX_INFO *pRRI) 
{
//-------------------------------------------------------------------------------------------------------
// (9) pRRI->pPayload[] :  Ȥ κ  Ÿ ó
//-------------------------------------------------------------------------------------------------------
	unsigned char Command, NOS, i;
	unsigned int Fromaddr, NOP;
	unsigned long INDEX;

	// Ŷ   ּ
	Fromaddr = pRRI->srcAddr;

	//  ڵ
	Command = pRRI->pPayload[0];

	//  м
	switch(Command)
	{
		case 1: // ͸ ϶ : κ
		{	
			Upperaddr = Fromaddr;
			NOS = pRRI->pPayload[1];
	
			if(NOS == 0) // Ⱑ  !   ۾..
			{
				NOP = ((unsigned int)pRRI->pPayload[2]) | ((unsigned int)(pRRI->pPayload[3])<<8);

				INDEX = (unsigned long)NOP * 100;

				// ܺθ޸𸮿 
				for(unsigned long eaddr = INDEX; eaddr < INDEX + 100; eaddr++)
				{
					wemem(eaddr,pRRI->pPayload[eaddr%100+4]);
				}

				// 忡  Ŷ 
				pTxBuffer[0] = 5; //    Ѵ
				pTxBuffer[1] = 0; // ڵ : !
				pTxBuffer[2] = rfSettings.myAddr & 0xFF; //  ּ Ʈ
				pTxBuffer[3] = ((rfSettings.myAddr & 0xFFFF) >> 8) & 0xFF; //  ּ Ʈ

				// Ŷ (C, ERR, FNst#_L,FNst#_H)  4 Ʈ 
				rfTxInfo.length = 4;

				// Ŷ   ּ
				rfTxInfo.destAddr = Upperaddr;

				// ߻!!
				basicRfSendPacket(&rfTxInfo);
			}
			else if(NOS > 0) //  ߰!  ޽ ..
			{
				NOS--; // NOS 
				
				Loweraddr = (unsigned int)(pRRI->pPayload[2]); //   ּ Ʈ
				Loweraddr |= ((unsigned int)(pRRI->pPayload[3]))<<8; //   ּ Ʈ
				
				//  忡 ۽ Ŷ 
				pTxBuffer[0] = Command; // 
				pTxBuffer[1] = NOS;

				for(i = 0 ; i < NOS*2 ; i += 2) //   ּҵ
				{
					pTxBuffer[2+i] = pRRI->pPayload[4+i];
					pTxBuffer[3+i] = pRRI->pPayload[5+i];
				}

				//  Ʈ  ۽ ۿ 
				for(i=NOS*2; i<NOS*2+102; i++)
				{
					pTxBuffer[2+i] = pRRI->pPayload[4+i];
				}

				// Ŷ ˿  NOS*2 + 104 Ʈ 
				rfTxInfo.length = NOS*2 + 104;

				// Ŷ    ּ
				rfTxInfo.destAddr = Loweraddr;

				// ߻!!
				basicRfSendPacket(&rfTxInfo);
			}

			break; // switch(Command) Ż

		} // case 1

		case 5: //    Ѵ : κ
		{
			//  忡 ۽ Ŷ 
			pTxBuffer[0] = 5; //    Ѵ
			pTxBuffer[1] = pRRI->pPayload[1]; // ڵ
			pTxBuffer[2] = pRRI->pPayload[2]; //  ּ Ʈ
			pTxBuffer[3] = pRRI->pPayload[3]; //  ּ Ʈ

			// Ŷ (C, ERR, FNst#_L,FNst#_H)  4 Ʈ 
			rfTxInfo.length = 4;

			// Ŷ   ּ
			rfTxInfo.destAddr = Upperaddr;

			// ߻!!
			basicRfSendPacket(&rfTxInfo);
	
			break; // switch(Command) Ż

		} // case 5	
			
		default: //  Ŷ 
		{
			// κ  ޽̸..
			if(Fromaddr == Loweraddr)
			{
				rfTxInfo.destAddr = Upperaddr; // 忡 

			}
			else rfTxInfo.destAddr = Fromaddr; // κ  ޽, 忡 

			// 忡 ۽ Ŷ 
			pTxBuffer[0] = 5; //    Ѵ
			pTxBuffer[1] = 2; // ڵ :   (Ŷ )
			pTxBuffer[2] = rfSettings.myAddr & 0xFF; //  ּ Ʈ
			pTxBuffer[3] = ((rfSettings.myAddr & 0xFFFF) >> 8) & 0xFF; //  ּ Ʈ

			// Ŷ ˿  4 Ʈ 
			rfTxInfo.length = 4;

			// ߻!!
			basicRfSendPacket(&rfTxInfo);

			break; // switch(Command) Ż
		}

	} // switch(Command)

	return pRRI; // Ŵ · 

} // basicRfReceivePacket

//-------------------------------------------------------------------------------------------------------
//	main Լ
//-------------------------------------------------------------------------------------------------------
int main(void) 
{
//-------------------------------------------------------------------------------------------------------
// (1) I/OƮ, , ATmega128 ġ  ֺġ ʱȭ
//-------------------------------------------------------------------------------------------------------
	unsigned int srcaddr;
	unsigned char x;

	PORT_INIT();
	SPI_INIT();
	ENABLE_EXT_RAM(); // ܺθ޸  ũ, MCUCR |= 0x80;
//	INIT_UART1(UART_BAUDRATE_115K2,UART_OPT_8_BITS_PER_CHAR); // UART1 ʱȭ(115.2 Kpbs)
//	ENABLE_UART1();

//-------------------------------------------------------------------------------------------------------
// (2) source address 
//-------------------------------------------------------------------------------------------------------
	srcaddr = 0x0002; //  巹 0x0002 ( ..)

//-------------------------------------------------------------------------------------------------------
// (3) ä  Pan ID 
//-------------------------------------------------------------------------------------------------------
	basicRfInit(&rfRxInfo, 26, 0x2176, srcaddr); // 26 ä , Pan ID = 0x2176( ..)

//-------------------------------------------------------------------------------------------------------
// (4) ۵Ÿ ũ 
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.length = 104; // 104 Ʈ ( ..) C, NOS, NOP_L, NOP_H, PCM DATA

//-------------------------------------------------------------------------------------------------------
// ACK   
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.ackRequest = TRUE;

	rfTxInfo.pPayload = pTxBuffer;
	rfRxInfo.pPayload = pRxBuffer;

//-------------------------------------------------------------------------------------------------------
// (5) ۵Ÿ ʱȭ
//-------------------------------------------------------------------------------------------------------
	for (unsigned char n = 0; n < 104; n++) 
	{
		pTxBuffer[n] = 0; // ۽  Ŭ
	}

	// Turn on RX mode
	basicRfReceiveOn();

//-------------------------------------------------------------------------------------------------------
// (6)  ƾ
//-------------------------------------------------------------------------------------------------------
	while(1) //  ݺ
	{
		for(unsigned long eaddr = 0; eaddr < 80000; eaddr++)
		{
			remem(eaddr,x);	// ܺθ޸𸮿 о
			PORTE = x;		// R2R DAC Ѵ
			halWait(100);	// PCM ø ֱ  (뷫 125 uSec)
		}

	} // while(1)

} // main()
