// PCDoc.cpp : implementation of the CPCDoc class
//

#include "stdafx.h"
#include "PC.h"

#include "PCDoc.h"
#include "ComDlg.h"
#include "PCView.h"
#include "MainFrm.h"
#include "PosDlg.h"

#include "mmsystem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPCDoc

IMPLEMENT_DYNCREATE(CPCDoc, CDocument)

BEGIN_MESSAGE_MAP(CPCDoc, CDocument)
	//{{AFX_MSG_MAP(CPCDoc)
	ON_COMMAND(ID_APP_EXIT, OnAppExit)
	ON_COMMAND(IDM_COM_SELECT, OnComSelect)
	ON_COMMAND(IDM_POS_SELECT, OnPosSelect)
	ON_COMMAND(IDM_RECORD, OnRecord)
	ON_COMMAND(IDM_PLAY, OnPlay)
	ON_COMMAND(IDM_TRANSMIT, OnTransmit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCDoc construction/destruction

CPCDoc::CPCDoc()
{
	// TODO: add one-time construction code here

}

CPCDoc::~CPCDoc()
{
}

BOOL CPCDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	//  ̺
	m_RT_TABLE[0][0] = 0x0001;	// SPK0 Ŀ(1) ּҴ 0x0001
	m_RT_TABLE[0][1] = 1;
	m_RT_TABLE[0][2] = 0x0001;

	m_RT_TABLE[1][0] = 0x0002;	// SPK1 Ŀ(2) ּҴ 0x0002
	m_RT_TABLE[1][1] = 2;
	m_RT_TABLE[1][2] = 0x0001;
	m_RT_TABLE[1][3] = 0x0002;

	m_SpkPos = 0;	// SPK0 Ŀ(1) ġ ʱⰪ 
	m_FnInuse = 0;
	m_PcBusy = 0;
	m_RxComplete = 0;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CPCDoc serialization

void CPCDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPCDoc diagnostics

#ifdef _DEBUG
void CPCDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPCDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPCDoc commands

void CPCDoc::OnAppExit() 
{
	// TODO: Add your command handler code here

	m_pSerial.Release();
	ExitProcess(TRUE);
}

void CPCDoc::OnComSelect() 
{
	// TODO: Add your command handler code here
	
	if(m_PcBusy == 1) return;

	CComDlg dlg;

	if(dlg.DoModal() == IDOK)
	{
		if((dlg.com > 0) && (dlg.com < 125))
		{
			m_pSerial.Stopcom();

			// Data bits(4-8), Stop bits(0,1,2:1,1.5,2), Parity(0-4=no,odd,even,mark,space)
			m_pSerial.Setting(dlg.com,921600,8,0,0); // 921.6Kbps, 8 Data bits, 1 Stop bit, No parity
			m_pSerial.Init();

			CPCView* pView = (CPCView*)((CMainFrame*)(AfxGetApp()->m_pMainWnd))->GetActiveView();

			if(!m_pSerial.Startcom()) 
			{
				m_strComport.Format("");
				pView->GetDlgItem(IDC_EDIT4)->SetWindowText(m_strComport);
				AfxMessageBox("Not Connected !");
			}
			else
			{
				m_strComport.Format("COM%d",dlg.com);
				pView->GetDlgItem(IDC_EDIT4)->SetWindowText(m_strComport);
			}

			UpdateAllViews(NULL);
			m_pSerial.SetHwnd(pView->m_hWnd); // WM_RECEIVEDATA ޽ CPCView Ŭ  
		}
		else AfxMessageBox("Not Selected !");
	}
}

void CPCDoc::OnPosSelect() 
{
	// TODO: Add your command handler code here
	
	if(m_PcBusy == 1) return;

	CPosDlg dlg;

	if(dlg.DoModal() == IDOK)
	{
		m_SpkPos = dlg.pos;
		m_strSpkpos.Format("SPK%d",m_SpkPos);

		CPCView* pView = (CPCView*)((CMainFrame*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
		pView->GetDlgItem(IDC_EDIT5)->SetWindowText(m_strSpkpos);

		UpdateAllViews(NULL);
	}
}

//    Լ
UINT ThreadRecord(LPVOID pParam)
{
	MCI_WAVE_SET_PARMS mciSetparms;
	MCI_STATUS_PARMS mciStatus;
	MCI_GENERIC_PARMS mciGeneric;
	MCI_OPEN_PARMS mciOpen;
	MCI_RECORD_PARMS mciRecord;
	MCI_SAVE_PARMS mciSave;
	MCIDEVICEID dwDeviceID;

	DWORD TotalLen, CurrentPos=0, dwSec, result=0;

	CPCDoc *pDoc = (CPCDoc *)pParam;
	CPCView* pView = (CPCView*)((CMainFrame*)(AfxGetApp()->m_pMainWnd))->GetActiveView();

	pDoc->m_PcBusy = 1; //   ۾ !

	pView->GetDlgItem(IDC_EDIT1)->SetWindowText((CString)"");

	// Open MCI device
	mciOpen.lpstrDeviceType = "waveaudio";
	mciOpen.lpstrElementName = "";
	
	result = mciSendCommand(0,MCI_OPEN,MCI_OPEN_ELEMENT|MCI_OPEN_TYPE,(DWORD)(LPVOID)&mciOpen);

	dwDeviceID = mciOpen.wDeviceID;

	// Wave parameter setting
	mciSetparms.wFormatTag = WAVE_FORMAT_PCM;
	mciSetparms.wBitsPerSample = 8;
	mciSetparms.nChannels = 1;
	mciSetparms.nSamplesPerSec = 8000;
	mciSetparms.nAvgBytesPerSec = ((mciSetparms.wBitsPerSample)/8) *
									mciSetparms.nChannels *
									mciSetparms.nSamplesPerSec;
	mciSetparms.nBlockAlign = ((mciSetparms.wBitsPerSample)/8) *
									mciSetparms.nChannels;

	result = mciSendCommand(dwDeviceID,MCI_SET,MCI_WAIT |
							MCI_WAVE_SET_FORMATTAG |
							MCI_WAVE_SET_BITSPERSAMPLE |
							MCI_WAVE_SET_CHANNELS |
							MCI_WAVE_SET_SAMPLESPERSEC |
							MCI_WAVE_SET_AVGBYTESPERSEC |
							MCI_WAVE_SET_BLOCKALIGN,
							(DWORD)(LPVOID)&mciSetparms);

	//  ð 
	dwSec = 10;
	mciRecord.dwTo = dwSec * 1000; // 10  !
	TotalLen = mciRecord.dwTo; //    : 10

	//  Progress Ʈ ʱȭ
	pView->m_record.SetRange(0,(short)TotalLen);
	pView->m_record.SetPos(0);

	mciStatus.dwItem = MCI_STATUS_POSITION;

	// 
	result = mciSendCommand(dwDeviceID,MCI_RECORD,MCI_TO|MCI_NOTIFY,(DWORD)(LPVOID)&mciRecord);

	//  ð  Progress Ʈ ۵
	while(CurrentPos < TotalLen)
	{
		mciSendCommand(dwDeviceID,MCI_STATUS,MCI_STATUS_ITEM,(DWORD)(LPVOID)&mciStatus);
		CurrentPos = mciStatus.dwReturn;
		pView->m_record.SetPos(CurrentPos);
	}

	//   Ϸ 
	mciSave.lpfilename = "tmpwav.wav";
	result = mciSendCommand(dwDeviceID,MCI_SAVE,MCI_SAVE_FILE|MCI_WAIT,(DWORD)(LPVOID)&mciSave);

	// Close MCI device
	result = mciSendCommand(dwDeviceID,MCI_CLOSE,MCI_WAIT,(DWORD)(LPVOID)&mciGeneric);

	//  Progress Ʈ ʱȭ
	pView->m_record.SetPos(0);

	pView->GetDlgItem(IDC_EDIT1)->SetWindowText((CString)"");

	pDoc->m_PcBusy = 0; //   ۾ !

	return 0;
}

void CPCDoc::OnRecord() 
{
	// TODO: Add your command handler code here
	
	if (m_PcBusy == 0)
	{
		//  
		AfxBeginThread(ThreadRecord, this);	
	}
}

//    Լ
UINT ThreadPlay(LPVOID pParam)
{
	MCI_STATUS_PARMS mciStatus;
	MCI_GENERIC_PARMS mciGeneric;
	MCI_OPEN_PARMS mciOpen;
	MCI_PLAY_PARMS mciPlay;
	MCIDEVICEID dwDeviceID;

	DWORD TotalLen, CurrentPos=0, result=0;

	CPCDoc *pDoc = (CPCDoc *)pParam;
	CPCView* pView = (CPCView*)((CMainFrame*)(AfxGetApp()->m_pMainWnd))->GetActiveView();

	pDoc->m_PcBusy = 1; //   ۾ !

	pView->GetDlgItem(IDC_EDIT2)->SetWindowText((CString)"");

	// Open MCI device
	mciOpen.lpstrDeviceType = "waveaudio";
	mciOpen.lpstrElementName = "tmpwav.wav";
	
	result = mciSendCommand(0,MCI_OPEN,MCI_WAIT|MCI_OPEN_ELEMENT,(DWORD)(LPVOID)&mciOpen);

	dwDeviceID = mciOpen.wDeviceID;

	//    ľ : 10
	mciStatus.dwItem = MCI_STATUS_LENGTH;
	mciSendCommand(dwDeviceID,MCI_STATUS,MCI_STATUS_ITEM,(DWORD)(LPVOID)&mciStatus);
	TotalLen = mciStatus.dwReturn;

	//  Progress Ʈ ʱȭ
	pView->m_play.SetRange(0,(short)TotalLen);
	pView->m_play.SetPos(0);

	mciStatus.dwItem = MCI_STATUS_POSITION;

	// 
	result = mciSendCommand(dwDeviceID,MCI_PLAY,MCI_NOTIFY,(DWORD)(LPVOID)&mciPlay);

	//  ð  Progress Ʈ ۵
	while(CurrentPos < TotalLen)
	{
		mciSendCommand(dwDeviceID,MCI_STATUS,MCI_STATUS_ITEM,(DWORD)(LPVOID)&mciStatus);
		CurrentPos = mciStatus.dwReturn;
		pView->m_play.SetPos(CurrentPos);
	}

	// Close MCI device
	result = mciSendCommand(dwDeviceID,MCI_CLOSE,MCI_WAIT,(DWORD)(LPVOID)&mciGeneric);

	//  Progress Ʈ ʱȭ
	pView->m_play.SetPos(0);

	pView->GetDlgItem(IDC_EDIT2)->SetWindowText((CString)"");

	pDoc->m_PcBusy = 0; //   ۾ !

	return 0;
}

void CPCDoc::OnPlay() 
{
	// TODO: Add your command handler code here

	if (m_PcBusy == 0)
	{
		//  
		AfxBeginThread(ThreadPlay, this);	
	}
}

//    Լ
UINT ThreadTransmit(LPVOID pParam)
{
	CPCDoc *pDoc = (CPCDoc *)pParam;
	CPCView* pView = (CPCView*)((CMainFrame*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	
	pDoc->m_PcBusy = 1; //   ۾ !
	pDoc->m_FnInuse = 1; //  

	pView->GetDlgItem(IDC_EDIT3)->SetWindowText((CString)"");

	// wav  б
	CFile cfile;
	if( !cfile.Open( "tmpwav.wav", CFile::modeRead ) )
	{
		AfxMessageBox("  Ͱ ϴ!");

		pView->GetDlgItem(IDC_EDIT3)->SetWindowText((CString)"");	

		pDoc->m_PcBusy = 0;
		pDoc->m_FnInuse = 0;

		return -1;
	}

	DWORD dwSize = cfile.GetLength();
	unsigned char *pWav;
	pWav = new unsigned char [dwSize];

	cfile.Read( pWav, dwSize );
	cfile.Close();

	// PCM  Ľ
	unsigned char *pPcm;
	pPcm = pWav + 44;

	//  Progress Ʈ ʱȭ
	pView->m_transmit.SetRange(0,800);
	pView->m_transmit.SetPos(0);

	/***************************************************************
	 pPcm 100 Ʈ   dwSize-44(= 80000) Ʈ PCM  
	***************************************************************/

	unsigned char TxPacket[109]; // Ŷ ִ = 109Ʈ =  9Ʈ + PCM  100Ʈ
	DWORD NOP, NOB;
	for(NOP=0; NOP<800; NOP++)
	{
		//  Ŷ  : Length, C, NOS, FN#_L, FN#_H, NOP_L, NOP_H, PCM DATA
		TxPacket[0] = pDoc->m_RT_TABLE[pDoc->m_SpkPos][1] * 2 + 104; // Length = 2*NOS + 104
		TxPacket[1] = 1; // Command
		TxPacket[2] = pDoc->m_RT_TABLE[pDoc->m_SpkPos][1]; // NOS

		for (unsigned int i=0; i<pDoc->m_RT_TABLE[pDoc->m_SpkPos][1]; i++)
		{
			TxPacket[i*2+3] = pDoc->m_RT_TABLE[pDoc->m_SpkPos][i+2] & 0xFF; // FN#_L 
			TxPacket[i*2+4] = ((pDoc->m_RT_TABLE[pDoc->m_SpkPos][i+2] & 0xFFFF) >> 8) & 0xFF; // FN#_H 
		}

		TxPacket[pDoc->m_RT_TABLE[pDoc->m_SpkPos][1]*2+3] = (unsigned char)(NOP & 0xFF); // NOP_L
		TxPacket[pDoc->m_RT_TABLE[pDoc->m_SpkPos][1]*2+4] = (unsigned char)(((NOP & 0xFFFF) >> 8) & 0xFF); // NOP_H

		for(NOB=0; NOB<100; NOB++) // PCM DATA 100 Ʈ
		{
			TxPacket[pDoc->m_RT_TABLE[pDoc->m_SpkPos][1]*2+5 + NOB] = *pPcm;
			pPcm++;
		}

		// ŸӾƿ 
		pDoc->m_Timeout = FALSE;
		SetTimer(*pView, 1, 10000, NULL); //  ŸӾƿ  : 10

		// øƮ ۽
		pDoc->m_pSerial.Output(&TxPacket[0], TxPacket[0] + 1);

		/***************************************************************
		 øƮ  κ  Ŷ 
		***************************************************************/

		while (!pDoc->m_RxComplete) // κ  
		{
			if(pDoc->m_Timeout == TRUE)
			{
				pDoc->m_RX_DATA[0] = 5; //     
				pDoc->m_RX_DATA[1] = 1; //  ()
				break;
			}
		}

		// κ  Ŷ ! Ÿ̸ 
		KillTimer(*pView, 1);

		pDoc->m_RxComplete = 0; // ʱȭ

		/***************************************************************
		  Ŷ м  ó
		***************************************************************/

		if(pDoc->m_RX_DATA[0] == 5) //     
		{
			switch(pDoc->m_RX_DATA[1]) //  ڵ
			{
				case 0: // ! for  ..
				{
					break;
				}
				case 1: //  ()!
				{
					CString str1;
					str1.Format("case 1: ()!");
					AfxMessageBox(str1);
					NOP = 9999; // for  Ż 
					break;
				}
				case 2: //  (Ŷ )!
				{
					CString str1;
					str1.Format("%x case 2: (Ŷ )!",pDoc->m_RX_DATA[2] | (pDoc->m_RX_DATA[3] << 8) );
					AfxMessageBox(str1);
					NOP = 9999; // for  Ż 
					break;
				}
				default: 
				{
					CString str1;
					str1.Format("%x default: (Ŷ )!",pDoc->m_RX_DATA[2] | (pDoc->m_RX_DATA[3] << 8) );
					AfxMessageBox(str1);
					NOP = 9999; // for  Ż 
					break;
				}
			}
		}
		else //  (Ŷ )!
		{
			AfxMessageBox(" ( Ŷ )!");
			NOP = 9999; // for  Ż 
		}

		//  ð  Progress Ʈ ۵
		pView->m_transmit.SetPos(NOP);

	} // for(NOP=0; NOP<800; NOP++)

	if (NOP == 800) AfxMessageBox("  Ϸ!");

	/***************************************************************
	  
	***************************************************************/

	//  Progress Ʈ ʱȭ
	pView->m_transmit.SetPos(0);
	pView->GetDlgItem(IDC_EDIT3)->SetWindowText((CString)"");	

	delete pWav; // PCM   
	pDoc->m_pSerial.bufread.Rstemp(); // øƮ   Ŭ
	pDoc->m_RxComplete = 0;
	pDoc->m_FnInuse = 0;
	pDoc->m_PcBusy = 0;

	return 0;
}

void CPCDoc::OnTransmit() 
{
	// TODO: Add your command handler code here

	if ((m_PcBusy == 0) && (m_FnInuse == 0))
	{
		//  
		AfxBeginThread(ThreadTransmit, this);	
	}
}
