/********************************************************************************************************
 * - PAN ID: 0x2176 for example										 								*
 * - Short address: 0x0000 ~ 0xFFFF changeable															*
 ********************************************************************************************************/

#include "include\include.h"

//-------------------------------------------------------------------------------------------------------
// Basic RF transmission and reception structures
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO rfRxInfo;
BASIC_RF_TX_INFO rfTxInfo;
BYTE pTxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];
BYTE pRxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];

//-------------------------------------------------------------------------------------------------------
// (7) ڰ ʿ信   ܺκ
//-------------------------------------------------------------------------------------------------------
//
//  ܺκ ߰
//

//-------------------------------------------------------------------------------------------------------
// (8) ڰ ʿ信   Լ ⿡ ϰų  .c Ͽ Ѵ.
//-------------------------------------------------------------------------------------------------------
//
//  Լ ߰
//

//-------------------------------------------------------------------------------------------------------
//	尡  Ÿ  ó Լ(ͷƮ ڵ鷯)
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO* basicRfReceivePacket(BASIC_RF_RX_INFO *pRRI) 
{
//-------------------------------------------------------------------------------------------------------
// (9) pRRI->pPayload[] : κ  Ÿ ó
//-------------------------------------------------------------------------------------------------------
	unsigned char Command;
	unsigned int Fromaddr;

	// Ŷ   ּ
	Fromaddr = pRRI->srcAddr;

	if(Fromaddr == rfTxInfo.destAddr) //  ϴ ޽ ߽ ּҰ   ´  
	{								  // ̸ּ.. κ  ޽!
		Command = pRRI->pPayload[0];

		//  м
		switch(Command)
		{
			case 5: //     ö!
			{
				// ǻ(PC) Ŷ ۽
				UART1_WAIT_AND_SEND(5); //    Ѵ
				UART1_WAIT_AND_SEND(pRRI->pPayload[1]); // ڵ
				UART1_WAIT_AND_SEND(pRRI->pPayload[2]); //  ּ Ʈ
				UART1_WAIT_AND_SEND(pRRI->pPayload[3]); //  ּ Ʈ

				break;
			}
			default: //     (Ŷ )
			{
				// ǻ(PC) Ŷ ۽
				UART1_WAIT_AND_SEND(5); //    Ѵ
				UART1_WAIT_AND_SEND(2); // ڵ :   (Ŷ )
				UART1_WAIT_AND_SEND(Fromaddr&0xFF); //   ּ Ʈ
				UART1_WAIT_AND_SEND((Fromaddr>>8)&0xFF); //   ּ Ʈ	
	
				break;
			}

		} // switch(Command)

	} // if(Fromaddr == rfTxInfo.destAddr)

	return pRRI; // Ŵ · 

} // basicRfReceivePacket

//-------------------------------------------------------------------------------------------------------
//	main Լ
//-------------------------------------------------------------------------------------------------------
int main(void) 
{
//-------------------------------------------------------------------------------------------------------
// (1) I/OƮ, , ATmega128 ġ  ֺġ ʱȭ
//-------------------------------------------------------------------------------------------------------
	unsigned int srcaddr, destaddr;
	unsigned char i, length, dest_L, dest_H;

	PORT_INIT();
	SPI_INIT();
	INIT_UART1(UART_BAUDRATE_921K6,UART_OPT_8_BITS_PER_CHAR); // UART1 ʱȭ(921.6Kbps)
	ENABLE_UART1();

//-------------------------------------------------------------------------------------------------------
// (2) source address 
//-------------------------------------------------------------------------------------------------------
	srcaddr = 0x0023; //  巹 0x0023 

//-------------------------------------------------------------------------------------------------------
// (3) ä  Pan ID 
//-------------------------------------------------------------------------------------------------------
	basicRfInit(&rfRxInfo, 26, 0x2176, srcaddr); // 26 ä , Pan ID = 0x2176( ..)

//-------------------------------------------------------------------------------------------------------
// (4) ۵Ÿ ũ 
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.length = 106; //  Ŷ,   ִ 106 Ʈ(C,NOS,FNst2_L,FNst2_H,NOP_L,NOP_H,PCMDATA)

//-------------------------------------------------------------------------------------------------------
// ACK   
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.ackRequest = TRUE;

	rfTxInfo.pPayload = pTxBuffer;
	rfRxInfo.pPayload = pRxBuffer;

//-------------------------------------------------------------------------------------------------------
// (5) ۵Ÿ ʱȭ
//-------------------------------------------------------------------------------------------------------
	for (unsigned char n = 0; n < 106; n++) 
	{
		pTxBuffer[n] = 0; // ۽  Ŭ
	}

	// Turn on RX mode
	basicRfReceiveOn();

//-------------------------------------------------------------------------------------------------------
// (6)  ƾ
//-------------------------------------------------------------------------------------------------------
	while(1) //  ݺ
	{
//-------------------------------------------------------------------------------------------------------
// (6-1)  ù°   ۽ Ŷ 
//-------------------------------------------------------------------------------------------------------
		// PCκ ù° Ʈ  : Length
		UART1_WAIT_AND_RECEIVE(length);

		// PCκ C Ͽ  ۽ ۿ 
		UART1_WAIT_AND_RECEIVE(pTxBuffer[0]);

		// PCκ NOS Ͽ  ۽ ۿ 
		UART1_WAIT_AND_RECEIVE(pTxBuffer[1]);

		// PCκ  ù°   ּ 
		UART1_WAIT_AND_RECEIVE(dest_L); //   ּ(low byte)
		UART1_WAIT_AND_RECEIVE(dest_H); //  ּ(high byte)

		// PCκ  Ʈ Ͽ  ۽ ۿ 
		for(i=2; i<length-2; i++)
		{
			UART1_WAIT_AND_RECEIVE(pTxBuffer[i]);
		}

		// NOS  1 
		pTxBuffer[1] = pTxBuffer[1] - 1;

//-------------------------------------------------------------------------------------------------------
// (6-2) destination address 
//-------------------------------------------------------------------------------------------------------
		//  ù°   ּ
		destaddr = (unsigned int)dest_L;
		destaddr |= (unsigned int)(dest_H)<<8;
		rfTxInfo.destAddr = destaddr;

//-------------------------------------------------------------------------------------------------------
// (6-3)  ۽
//-------------------------------------------------------------------------------------------------------

		rfTxInfo.length = length - 2;

		//    Ŷ ߻!
		basicRfSendPacket(&rfTxInfo);

	} // while(1)

} // main()
